# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc
import warnings

from deephaven_core.proto import partitionedtable_pb2 as deephaven__core_dot_proto_dot_partitionedtable__pb2
from deephaven_core.proto import table_pb2 as deephaven__core_dot_proto_dot_table__pb2

GRPC_GENERATED_VERSION = '1.63.0'
GRPC_VERSION = grpc.__version__
EXPECTED_ERROR_RELEASE = '1.65.0'
SCHEDULED_RELEASE_DATE = 'June 25, 2024'
_version_not_supported = False

try:
    from grpc._utilities import first_version_is_lower
    _version_not_supported = first_version_is_lower(GRPC_VERSION, GRPC_GENERATED_VERSION)
except ImportError:
    _version_not_supported = True

if _version_not_supported:
    warnings.warn(
        f'The grpc package installed is at version {GRPC_VERSION},'
        + f' but the generated code in deephaven_core/proto/partitionedtable_pb2_grpc.py depends on'
        + f' grpcio>={GRPC_GENERATED_VERSION}.'
        + f' Please upgrade your grpc module to grpcio>={GRPC_GENERATED_VERSION}'
        + f' or downgrade your generated code using grpcio-tools<={GRPC_VERSION}.'
        + f' This warning will become an error in {EXPECTED_ERROR_RELEASE},'
        + f' scheduled for release on {SCHEDULED_RELEASE_DATE}.',
        RuntimeWarning
    )


class PartitionedTableServiceStub(object):
    """
    This service provides tools to create and query partitioned tables.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.PartitionBy = channel.unary_unary(
                '/io.deephaven.proto.backplane.grpc.PartitionedTableService/PartitionBy',
                request_serializer=deephaven__core_dot_proto_dot_partitionedtable__pb2.PartitionByRequest.SerializeToString,
                response_deserializer=deephaven__core_dot_proto_dot_partitionedtable__pb2.PartitionByResponse.FromString,
                _registered_method=True)
        self.Merge = channel.unary_unary(
                '/io.deephaven.proto.backplane.grpc.PartitionedTableService/Merge',
                request_serializer=deephaven__core_dot_proto_dot_partitionedtable__pb2.MergeRequest.SerializeToString,
                response_deserializer=deephaven__core_dot_proto_dot_table__pb2.ExportedTableCreationResponse.FromString,
                _registered_method=True)
        self.GetTable = channel.unary_unary(
                '/io.deephaven.proto.backplane.grpc.PartitionedTableService/GetTable',
                request_serializer=deephaven__core_dot_proto_dot_partitionedtable__pb2.GetTableRequest.SerializeToString,
                response_deserializer=deephaven__core_dot_proto_dot_table__pb2.ExportedTableCreationResponse.FromString,
                _registered_method=True)


class PartitionedTableServiceServicer(object):
    """
    This service provides tools to create and query partitioned tables.
    """

    def PartitionBy(self, request, context):
        """
        Transforms a table into a partitioned table, consisting of many separate tables, each individually
        addressable. The result will be a FetchObjectResponse populated with a PartitionedTable.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Merge(self, request, context):
        """
        Given a partitioned table, returns a table with the contents of all of the constituent tables.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetTable(self, request, context):
        """
        Given a partitioned table and a row described by another table's contents, returns a table
        that matched that row, if any. If none is present, NOT_FOUND will be sent in response. If
        more than one is present, FAILED_PRECONDITION will be sent in response.

        If the provided key table has any number of rows other than one, INVALID_ARGUMENT will be
        sent in response.

        The simplest way to generally use this is to subscribe to the key columns of the underlying
        table of a given PartitionedTable, then use /FlightService/DoPut to create a table with the
        desired keys, and pass that ticket to this service. After that request is sent (note that it
        is not required to wait for it to complete), that new table ticket can be used to make this
        GetTable request.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_PartitionedTableServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'PartitionBy': grpc.unary_unary_rpc_method_handler(
                    servicer.PartitionBy,
                    request_deserializer=deephaven__core_dot_proto_dot_partitionedtable__pb2.PartitionByRequest.FromString,
                    response_serializer=deephaven__core_dot_proto_dot_partitionedtable__pb2.PartitionByResponse.SerializeToString,
            ),
            'Merge': grpc.unary_unary_rpc_method_handler(
                    servicer.Merge,
                    request_deserializer=deephaven__core_dot_proto_dot_partitionedtable__pb2.MergeRequest.FromString,
                    response_serializer=deephaven__core_dot_proto_dot_table__pb2.ExportedTableCreationResponse.SerializeToString,
            ),
            'GetTable': grpc.unary_unary_rpc_method_handler(
                    servicer.GetTable,
                    request_deserializer=deephaven__core_dot_proto_dot_partitionedtable__pb2.GetTableRequest.FromString,
                    response_serializer=deephaven__core_dot_proto_dot_table__pb2.ExportedTableCreationResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'io.deephaven.proto.backplane.grpc.PartitionedTableService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class PartitionedTableService(object):
    """
    This service provides tools to create and query partitioned tables.
    """

    @staticmethod
    def PartitionBy(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/io.deephaven.proto.backplane.grpc.PartitionedTableService/PartitionBy',
            deephaven__core_dot_proto_dot_partitionedtable__pb2.PartitionByRequest.SerializeToString,
            deephaven__core_dot_proto_dot_partitionedtable__pb2.PartitionByResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def Merge(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/io.deephaven.proto.backplane.grpc.PartitionedTableService/Merge',
            deephaven__core_dot_proto_dot_partitionedtable__pb2.MergeRequest.SerializeToString,
            deephaven__core_dot_proto_dot_table__pb2.ExportedTableCreationResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def GetTable(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/io.deephaven.proto.backplane.grpc.PartitionedTableService/GetTable',
            deephaven__core_dot_proto_dot_partitionedtable__pb2.GetTableRequest.SerializeToString,
            deephaven__core_dot_proto_dot_table__pb2.ExportedTableCreationResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)
