# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc
import warnings

from deephaven_core.proto import storage_pb2 as deephaven__core_dot_proto_dot_storage__pb2

GRPC_GENERATED_VERSION = '1.63.0'
GRPC_VERSION = grpc.__version__
EXPECTED_ERROR_RELEASE = '1.65.0'
SCHEDULED_RELEASE_DATE = 'June 25, 2024'
_version_not_supported = False

try:
    from grpc._utilities import first_version_is_lower
    _version_not_supported = first_version_is_lower(GRPC_VERSION, GRPC_GENERATED_VERSION)
except ImportError:
    _version_not_supported = True

if _version_not_supported:
    warnings.warn(
        f'The grpc package installed is at version {GRPC_VERSION},'
        + f' but the generated code in deephaven_core/proto/storage_pb2_grpc.py depends on'
        + f' grpcio>={GRPC_GENERATED_VERSION}.'
        + f' Please upgrade your grpc module to grpcio>={GRPC_GENERATED_VERSION}'
        + f' or downgrade your generated code using grpcio-tools<={GRPC_VERSION}.'
        + f' This warning will become an error in {EXPECTED_ERROR_RELEASE},'
        + f' scheduled for release on {SCHEDULED_RELEASE_DATE}.',
        RuntimeWarning
    )


class StorageServiceStub(object):
    """
    Shared storage management service.

    Operations may fail (or omit data) if the current session does not have permission to read or write that resource.

    Paths will be "/" delimited and must start with a leading slash.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.ListItems = channel.unary_unary(
                '/io.deephaven.proto.backplane.grpc.StorageService/ListItems',
                request_serializer=deephaven__core_dot_proto_dot_storage__pb2.ListItemsRequest.SerializeToString,
                response_deserializer=deephaven__core_dot_proto_dot_storage__pb2.ListItemsResponse.FromString,
                _registered_method=True)
        self.FetchFile = channel.unary_unary(
                '/io.deephaven.proto.backplane.grpc.StorageService/FetchFile',
                request_serializer=deephaven__core_dot_proto_dot_storage__pb2.FetchFileRequest.SerializeToString,
                response_deserializer=deephaven__core_dot_proto_dot_storage__pb2.FetchFileResponse.FromString,
                _registered_method=True)
        self.SaveFile = channel.unary_unary(
                '/io.deephaven.proto.backplane.grpc.StorageService/SaveFile',
                request_serializer=deephaven__core_dot_proto_dot_storage__pb2.SaveFileRequest.SerializeToString,
                response_deserializer=deephaven__core_dot_proto_dot_storage__pb2.SaveFileResponse.FromString,
                _registered_method=True)
        self.MoveItem = channel.unary_unary(
                '/io.deephaven.proto.backplane.grpc.StorageService/MoveItem',
                request_serializer=deephaven__core_dot_proto_dot_storage__pb2.MoveItemRequest.SerializeToString,
                response_deserializer=deephaven__core_dot_proto_dot_storage__pb2.MoveItemResponse.FromString,
                _registered_method=True)
        self.CreateDirectory = channel.unary_unary(
                '/io.deephaven.proto.backplane.grpc.StorageService/CreateDirectory',
                request_serializer=deephaven__core_dot_proto_dot_storage__pb2.CreateDirectoryRequest.SerializeToString,
                response_deserializer=deephaven__core_dot_proto_dot_storage__pb2.CreateDirectoryResponse.FromString,
                _registered_method=True)
        self.DeleteItem = channel.unary_unary(
                '/io.deephaven.proto.backplane.grpc.StorageService/DeleteItem',
                request_serializer=deephaven__core_dot_proto_dot_storage__pb2.DeleteItemRequest.SerializeToString,
                response_deserializer=deephaven__core_dot_proto_dot_storage__pb2.DeleteItemResponse.FromString,
                _registered_method=True)


class StorageServiceServicer(object):
    """
    Shared storage management service.

    Operations may fail (or omit data) if the current session does not have permission to read or write that resource.

    Paths will be "/" delimited and must start with a leading slash.
    """

    def ListItems(self, request, context):
        """Lists the files and directories present in a given directory. Will return an error
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def FetchFile(self, request, context):
        """Reads the file at the given path. Client can optionally specify an etag, asking the server
        not to send the file if it hasn't changed.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def SaveFile(self, request, context):
        """Can create new files or modify existing with client provided contents.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def MoveItem(self, request, context):
        """Moves a file from one path to another.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def CreateDirectory(self, request, context):
        """Creates a directory at the given path.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeleteItem(self, request, context):
        """Deletes the file or directory at the given path. Directories must be empty to be deleted.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_StorageServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'ListItems': grpc.unary_unary_rpc_method_handler(
                    servicer.ListItems,
                    request_deserializer=deephaven__core_dot_proto_dot_storage__pb2.ListItemsRequest.FromString,
                    response_serializer=deephaven__core_dot_proto_dot_storage__pb2.ListItemsResponse.SerializeToString,
            ),
            'FetchFile': grpc.unary_unary_rpc_method_handler(
                    servicer.FetchFile,
                    request_deserializer=deephaven__core_dot_proto_dot_storage__pb2.FetchFileRequest.FromString,
                    response_serializer=deephaven__core_dot_proto_dot_storage__pb2.FetchFileResponse.SerializeToString,
            ),
            'SaveFile': grpc.unary_unary_rpc_method_handler(
                    servicer.SaveFile,
                    request_deserializer=deephaven__core_dot_proto_dot_storage__pb2.SaveFileRequest.FromString,
                    response_serializer=deephaven__core_dot_proto_dot_storage__pb2.SaveFileResponse.SerializeToString,
            ),
            'MoveItem': grpc.unary_unary_rpc_method_handler(
                    servicer.MoveItem,
                    request_deserializer=deephaven__core_dot_proto_dot_storage__pb2.MoveItemRequest.FromString,
                    response_serializer=deephaven__core_dot_proto_dot_storage__pb2.MoveItemResponse.SerializeToString,
            ),
            'CreateDirectory': grpc.unary_unary_rpc_method_handler(
                    servicer.CreateDirectory,
                    request_deserializer=deephaven__core_dot_proto_dot_storage__pb2.CreateDirectoryRequest.FromString,
                    response_serializer=deephaven__core_dot_proto_dot_storage__pb2.CreateDirectoryResponse.SerializeToString,
            ),
            'DeleteItem': grpc.unary_unary_rpc_method_handler(
                    servicer.DeleteItem,
                    request_deserializer=deephaven__core_dot_proto_dot_storage__pb2.DeleteItemRequest.FromString,
                    response_serializer=deephaven__core_dot_proto_dot_storage__pb2.DeleteItemResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'io.deephaven.proto.backplane.grpc.StorageService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class StorageService(object):
    """
    Shared storage management service.

    Operations may fail (or omit data) if the current session does not have permission to read or write that resource.

    Paths will be "/" delimited and must start with a leading slash.
    """

    @staticmethod
    def ListItems(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/io.deephaven.proto.backplane.grpc.StorageService/ListItems',
            deephaven__core_dot_proto_dot_storage__pb2.ListItemsRequest.SerializeToString,
            deephaven__core_dot_proto_dot_storage__pb2.ListItemsResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def FetchFile(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/io.deephaven.proto.backplane.grpc.StorageService/FetchFile',
            deephaven__core_dot_proto_dot_storage__pb2.FetchFileRequest.SerializeToString,
            deephaven__core_dot_proto_dot_storage__pb2.FetchFileResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def SaveFile(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/io.deephaven.proto.backplane.grpc.StorageService/SaveFile',
            deephaven__core_dot_proto_dot_storage__pb2.SaveFileRequest.SerializeToString,
            deephaven__core_dot_proto_dot_storage__pb2.SaveFileResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def MoveItem(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/io.deephaven.proto.backplane.grpc.StorageService/MoveItem',
            deephaven__core_dot_proto_dot_storage__pb2.MoveItemRequest.SerializeToString,
            deephaven__core_dot_proto_dot_storage__pb2.MoveItemResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def CreateDirectory(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/io.deephaven.proto.backplane.grpc.StorageService/CreateDirectory',
            deephaven__core_dot_proto_dot_storage__pb2.CreateDirectoryRequest.SerializeToString,
            deephaven__core_dot_proto_dot_storage__pb2.CreateDirectoryResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def DeleteItem(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/io.deephaven.proto.backplane.grpc.StorageService/DeleteItem',
            deephaven__core_dot_proto_dot_storage__pb2.DeleteItemRequest.SerializeToString,
            deephaven__core_dot_proto_dot_storage__pb2.DeleteItemResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)
